<?php
require_once( 'myconfig.php' );
require_once( 'NikkiTables.class.php' );
require_once( 'NikkiObject.class.php' );
require_once( 'MDB2.php' );
require_once( 'MDB2/Date.php' );


class NikkiContent extends NikkiObject {
    var $get;       // $_GET[]
    var $post;      // $_POST[]
    
    // コンストラクタ
    function NikkiContent() {
		global $_POST;
		global $_GET;
		
	  parent::NikkiObject();
	  // trimを実行しておくが無害化は行わない
      $this->get = array_map( "trim", $_GET );
      $this->post = array_map( "trim", $_POST );
    }
    
    // このオブジェクトのメインコンテンツを返す
    function getContents() {
		return "";
	}
    
    // このオブジェクトのページタイトルを返す
    function getTitle() {
		return "";
	}
    
    // サイドメニューを返す
    function getSideMenu() {
		return "";
	}
	
	// methodを実行
	function action( $method ) {
		global $DSN;
		
		// ポスト実行標準動作
		if( $method == "post" ) {
			if( ! array_key_exists( "table_name", $this->post ) ) {
				$this->setError( "テーブルが指定されていません" );
				return;
			}
			if( ! array_key_exists( "id" , $this->post) ) {
				$this->setError( "idが指定されていません" );
				return;
			}
			$table_name = $this->post['table_name'];
			if( ! class_exists( $table_name ) ) {
				$this->setError( "$table_name はありません" );
				return;
			}
			$table =& new $table_name ( $DSN, "id", $this->post['id'] );
			if( $table->isError() ) {
				$this->setError( $table->getError() );
				return;
			}
			if( ! is_subclass_of( $table, "DBTable" ) ) {
				$this->setError( "$table_name は不正です" );
				$this->close();
				return;
			}
			$def = $table->getDefinition();
			$fields = array_keys( $def );
			foreach( $fields as $field ) {
				// idは書き込めない
				if( $field == "id" ) continue;
				if( array_key_exists( $field, $this->post ) ) {
					$value = $this->post[$field];
					if( ($def[$field]['type'] == "timestamp") && ($value == "NOW") )
						$value = MDB2_Date::mdbNow();
					if( ($def[$field]['type'] == "time") && ($value == "NOW") )
						$value = MDB2_Date::mdbTime();
					if( ($def[$field]['type'] == "date") && ($value == "TODAY") ) 
						$value = MDB2_Date::mdbToday();
					$table->set( $field, $value );
					if( $table->isError() )  {
						$this->setError( $table->getError() );
						$table->close();
						return;
					}
				}
			}

			$table->close();

		}
	}
  }
?>