<?php

require_once( 'NikkiTable.class.php' );

// 日記テーブル群

// 設定テーブルTbl_Settings

class Tbl_Settings extends NikkiTable {
	
	// テーブル構造
	var $definition = array(
		'id' => array(
			'type' => 'integer',
			'autoincrement' => 'true',	// mysqlドライバでは自動的にprimary keyになる
		),
		'maintitle' => array(
			'type' => 'text',
			'length' => 256,
			'default' => '',
		),
		'subtitle' => array(
			'type' => 'text',
			'lenghth' => 256,
			'default'=> '',
		),
		'maxtopics' => array(
			'type' => 'integer',
			'default' => 20,
		),
		'username' => array(
			'type' => 'text',
			'length' => 256,
			'default' => '',
		),
		'siteuri' => array(
			'type' => 'text',
			'length' => 1024,
			'default' => '',
		),
		'password' => array(
			'type' => 'text',
			'length' => 256,
			'default' => '',
		),
		
		'mailaddr' => array(
			'type' => 'text',
			'length' => 256,
			'default' => '',
		),
	);
	
	function Tbl_Settings( $dsn, $property = null, $value = null ) {
		$this->permission = TBL_ADMIN_WRITE_PERMIT | TBL_PUB_READ_PERMIT;
		parent::NikkiTable( $dsn, $property, $value );
	}
}

// カテゴリテーブル

class Tbl_Categories extends NikkiTable {
	
	// 管理者のみ書き込み可
	// テーブル構造
	var $definition = array(
		'id' => array(
			'type' => 'integer',
			'autoincrement' => 'true',
		),
		'category' => array(
			'type' => 'text',
			'length' => 256,
			'default' => '',
		),
	);
	
	function Tbl_Categories( $dsn, $property = null, $value = null ) {
		$this->permission = TBL_ADMIN_WRITE_PERMIT | TBL_PUB_READ_PERMIT;
		parent::NikkiTable( $dsn, $property, $value );
	}
}

class Tbl_Nikki extends NikkiTable {
	
	// 管理者のみ書き込み可
	var $definition = array(
		'id' => array(
			'type' => 'integer',
			'autoincrement' => 'true',
		),
		
		'dt' => array(
			'type' => 'timestamp',
			'default' => null,
		),
		'lastupdate' => array(
			'type' => 'timestamp',
			'default' => null,
		),
		'fdelete' => array(
			'type' => 'boolean',
			'default' => false,
		),
		'catid' => array(
			'type' => 'integer',
			'default' => 1,
		),
		'title' => array( 
			'type' => 'text',
			'default' => '',
		),
		'body' => array(
			'type' => 'text',
			'default' => '',
		),
	);

	function Tbl_Nikki( $dsn, $property = null, $value = null ) {
		$this->permission = TBL_ADMIN_WRITE_PERMIT | TBL_PUB_READ_PERMIT;
		parent::NikkiTable( $dsn, $property, $value );
	}
}

?>