<?php
  //
  // 管理画面を表示する
  //
  include_once( 'myconfig.php' );
  include_once( 'NikkiContent.class.php' );
  include_once( 'admin/Auth.class.php' );
  include_once( 'Smarty.class.php' );
  
	// セッション
	ini_set( "session.use_cookie" ,1 );
	ini_set( "session.use_only_cookies",1 );
	ini_set( "session.use_trans_sid",0 );
	session_start();

  // コンテンツ定義定義
  $adminplugs = array( "Top", "ChangeSettings" , "EditCategories" , "EditTopic",  "ListTopics", "Auth" );
  
  $smarty = new Smarty();
  $smarty->assign("adminpagemode", 1);
  
  // GETメソッドで指定されたクラスを生成し画面を作る
  $content = "Top";
  if( isset( $_GET['content'] ) ) {
    if( ! in_array( $_GET['content'], $adminplugs ) ) {
		// あり得ないことが起きた
		exit( "指定されたコンテンツは無効です" );
    }
    else
      $content = trim($_GET['content']);
  }
  
  // 管理ページではまず認証チェックを行う
  if( $_SESSION['permission'] != ADMIN ) {
	
	// 認証されていないならログインページを強制表示
	$content = "Auth";
  }
  
  // エラーを渡されたなら
  if( isset( $_GET['isError'] ) )
	$smarty->assign("error_message", htmlspecialchars($_GET['isError'], ENT_QUOTES) );
  
  // サイドメニューを作成する
  $plugs = array();
  $links = array();
  
  for( $i=0 ; $i < count($adminplugs); $i++ ) {
    include_once( "admin/".$adminplugs[$i].".class.php" );
    $classname = $adminplugs[$i];
    $menuitem = eval("return $classname::getSideMenu();");
    array_push( $plugs, $menuitem );
  }
  $smarty->assign("plugs", $plugs);
  $smarty->assign("links", $links);

  // 日記タイトルを得る
  $settings =& new Tbl_Settings( $DSN, "id", "1" );
  if( $settings->isError() ) {
	exit( $settings->getError() );
	}
  
  $smarty->assign('maintitle', $settings->get("maintitle") );
  $settings->close();
  
  $cont =& new $content ();
  
  // アクションがあればactionメソッドを呼ぶ
  if( isset($_GET['action']) ) {
	$cont->action( $_GET['action'] );
	if( $cont->isError() ) 
		$smarty->assign("error_message", $cont->getError() );
  }
  // 管理コンテンツタイトル
  $smarty->assign("admintitle", $cont->getTitle() );
  // 管理コンテンツ表示
  $smarty->assign("body", $cont->getContents() );
  if( $cont->isError() ) 
  	$smarty->assign("error_message", $cont->getError() );
  
  $smarty->display("adminpage.tpl");
  exit();
?>