<?php
require_once( "myconfig.php" );
require_once( "NikkiContent.class.php" );
require_once( "NikkiTables.class.php" );
require_once( "Category.class.php" );
require_once( "Smarty.class.php" );

class ListTopics extends NikkiContent {
	
	function ListTopics() {
		parent::NikkiContent();
	}
	
	function getTitle() {
		return "トピックの管理";
	}
	
	function getSideMenu() {
		return '<a href="admin.php?content=ListTopics">トピックの管理</a>';
	}
	
	function getContents() {
		global $DSN;
		
		// 過去50件を表示する
		$options = "order by id desc limit 50";
		$arr = array();
		if( isset( $this->get["id"]) ){
			$options = "where id < ? ".$options;
			$arr = array(  $this->get["id"] );
		}
		
		$smarty =& new Smarty();
		$nikki =& new Tbl_Nikki( $DSN );
		if( $nikki->isError() ) {
			$this->setError( $nikki->getError() );
			return;
		}
		$topics = $nikki->fetch_array( $options, $arr );
		$smarty->assign("topics", $topics );
		$smarty->assign("id", $topics[count($topics)-1]["id"] );
		$nikki->close();
		return $smarty->fetch("topiclist.tpl");
	}
	
	function action( $method ) {
		global $DSN;
		
		if( $method == "delete" ) {
			$nikki =& new Tbl_Nikki( $DSN );
			$nikki->delete( "where fdelete = ?", array( true ) );
			if( $nikki->isError() ) {
				$this->setError( $nikki->getError() );
			}
			$nikki->close();
		}
	}
}
?>