<?php

include_once( 'myconfig.php' );
include_once( 'NikkiContent.class.php' );
include_once( 'NikkiTable.class.php' );
include_once( 'Smarty.class.php' );
include_once( 'MDB2/Date.php' );

class Main extends NikkiContent {
	
	function Main() {
		parent::NikkiContent();
	}
	
	function getContents() {
		global $DSN;
		
		$smarty = new Smarty();
		// あらかじめ設定を取り出しておく
		$settings =& new Tbl_Settings( $DSN, "id", "1" );
		$maxtopics = $settings->get("maxtopics");
		$settings->close();
		
		$where = "where fdelete <> '1' ";
		$arr = array();
		// 単一ID指定
		if( isset( $this->get["id"] ) ) {
			$where .= "and id = ? ";
			array_push( $arr, $this->get["id"]  );
		}
		else {
			// 過去ログ検索
			if( isset( $this->get["log"])) {
				$where .= "and id < ? ";
				array_push( $arr, $this->get["log"] );
			}
			// 本文検索
			if( isset( $this->get["search"])) {
				$where .= "and body like ? ";
				array_push( $arr, "%".$this->get["search"]."%" );
				$smarty->assign( "searchstr", 
					htmlspecialchars( $this->get["search"], ENT_QUOTES ) );
			}
			// カテゴリ検索
			if( isset( $this->get["catid"]) ) {
				$cat =& new Tbl_Categories( $DSN, "id", $this->get["catid"] );
				if( ! $cat->isError() ) {
					$smarty->assign("cattitle", $cat->get("category") );
					$cat->close();
					$where .= "and catid = ? ";
					array_push( $arr, $this->get["catid"]);
				}
				else {
					// エラーなら無視
				}
			}
		}
		$nikki =& new Tbl_Nikki( $DSN );
		if( $nikki->isError() ) {
			$this->setError( $nikki->getError() );
			return;
		}
		$topics = $nikki->fetch_array( $where."order by id desc limit ".$maxtopics, $arr );
		if( count($topics) == 0 ) {
			return '<div><a href="index.php">指定されたトピックはありません（トップに戻る）</a></div>';
		}
		// コンテンツ取り出しに成功
		// 日付ごとの配列に変える
		$cat =& new Tbl_Categories( $DSN );
		$dtopics = array();
		$now = "";
		$daycount = -1;
		$tcount = 0;
		foreach( $topics as $topic ) {
			$dt = MDB2_Date::mdbstamp2Date( $topic["dt"] );
			if( $now != $dt['year'].$dt['month'].$dt['day'] ) {
				// 日付を変える
				$now = $dt['year'].$dt['month'].$dt['day'];
				$tcount = 0;
				$daycount++;
				
				$dtopics[$daycount]['year']  = $dt['year'];
				$dtopics[$daycount]['month'] = $dt['month'];
				$dtopics[$daycount]['day']   = $dt['day'];
			}
			$dtopics[$daycount]['topics'][$tcount] = $topic;
			$category = $cat->fetch_array("where id = ?", array( $topic['catid']) );
			if( !$cat->isError() && count($category) )
				$dtopics[$daycount]['topics'][$tcount]['category'] = $category[0]['category'];
			$tcount++;
		}
		$smarty->assign("dtopics" , $dtopics );
		// ログへのリンク
		$lastid = $topics[count($topics)-1]['id'];
		$next = "";
		$tmp = $nikki->fetch_array("where fdelete <> '1' and id < ?", array($lastid) );
		if( count($tmp) && !isset($this->get['id']) ) {
			$next = '<a href="index.php?log='.$lastid;
			if( isset($this->get['search'] ) )
				$next .= '&search='.urlencode($this->get['search']);
			if( isset($this->get['catid']) )
				$next .= '&catid='.$this->get['catid'];
			
			$next .= '">次へ</a>';
		}
		else
			$next = '<a href="index.php">トップに戻る</a>';
		$smarty->assign("next", $next );
		
		$nikki->close();
		$cat->close();
		return $smarty->fetch("main.tpl");
	}
	
	function getSideMenu() {
		return '<a href="index.php">ホーム</a>';
	}
}
?>