<?php
include_once( 'myconfig.php' );
include_once( 'NikkiContent.class.php' );
include_once( 'NikkiTable.class.php' );
include_once( 'Smarty.class.php' );
include_once( 'akismet.class.php' );


class NewComment extends NikkiContent {
	
	function NewComment() {
		parent::NikkiContent();
	}
	
	function getContents() {
		global $DSN;
		global $_SESSION;
		global $_SERVER;
		
		// idが指定されたときのみ表示する
		
		if( isset($this->get['id']) ) {
			$smarty =& new Smarty();
			
			// IP/Hostnameをフォームに埋め込むのは中止
//			$smarty->assign("ipaddr", $_SERVER['REMOTE_ADDR'] );
//			$smarty->assign("hostname", gethostbyaddr($_SERVER['REMOTE_ADDR']));
			$smarty->assign("tid" , htmlspecialchars($this->get['id'],ENT_QUOTES));
			
			return $smarty->fetch("newcomment.tpl");
		}
		else
			return "";
	}
	
	// コメントのポスト
	function action( $method ) {
		global $DSN;
		global $_SESSION;
		global $API_KEY;
		
		if( $method == "addcomment" ) {
			if( isset($_SESSION['addcomment']) ) {
				$this->setError("連続投稿はできません");
				return;
			}
			if( ($this->post['name'] == "") || 
				($this->post['body'] == "") ) {
				$this->setError("名前や本文が空のコメントは投稿できません");
				return;
			}
			
			$settings =& new Tbl_Settings( $DSN, "id", "1" );
			$siteuri = $settings->get("siteuri");
			$settings->close();
			
			// Akismet Spamフィルタ
			$comment = array(
				'author' => $this->post['name'],
				'email' => $this->post['mailaddr'],
				'body' => $this->post['body'],
				'permalink' => $siteuri."?id=".$this->post['tid'],
			);
			$akismet =& new Akismet( $siteuri, $API_KEY, $comment);
			if( $akismet->errorsExist() ) {
				$this->setError("スパムフィルタの異常です（しばらく待って投稿してください）");
				return;
			}
			$akismet->setComment($comment);
			if( $akismet->isSpam() ) {
				$this->setError("スパムフィルタが作動しました");
				$_SESSION['addcomment'] = 1;
				return;
			}
			else {
				// IP/Hostnameをセット
				$this->post['ipaddr'] = $_SERVER['REMOTE_ADDR'];
				$this->post['hostname'] = gethostbyaddr($_SERVER['REMOTE_ADDR']);
				// 一時的に書き込みを許可
				$_SESSION['permission'] |= TBL_PUB_WRITE_PERMIT;
				parent::action("post");
				$_SESSION['permission'] &= ~TBL_PUB_WRITE_PERMIT;
				if( ! $this->isError() )
					$_SESSION['addcomment'] = 1;
				return;
			}
		}
	}
}
?>
