<?php
require_once( "myconfig.php" );
require_once( "NikkiTable.class.php" );
require_once( "Tbl_Comments.class.php" );
require_once( "Tbl_Trackbacks.class.php" );

class EditComment extends NikkiContent {
	
	
	function EditComment() {
		parent::NikkiContent();
	}
	
	function getSideMenu() {
		return '<a href="admin.php?content=EditComment">コメント/トラックバック管理</a>';
	}
	
	function getContents() {
		global $DSN;
		
		
		$smarty = new Smarty();
		// コメント一覧
		$comments =& new Tbl_Comments( $DSN );
		if( $comments->isError() ) {
			$this->setError($comments->isError());
			return;
		}
		$arr = $comments->fetch_array();	// 全部読み出す
		if( count($arr) ) {
			$smarty->assign( "comments" , $arr );
			$smarty->assign( "fcomment" , "t" );
		}
		else {
			$smarty->assign( "fcomment" , "f" );
		}
		$comments->close();
		
		// トラックバック一覧
		$trackbacks =& new Tbl_Trackbacks( $DSN );
		if( $trackbacks->isError() ) {
			$this->setError($trackbacks->isError());
			return;
		}
		$arr = $trackbacks->fetch_array();	// 全部読み出す
		if( count($arr) ) {
			$smarty->assign( "trackbacks" , $arr );
			$smarty->assign( "ftrackback" , "t" );
		}
		else {
			$smarty->assign( "ftrackback" , "f" );
		}
		$trackbacks->close();
		
		return $smarty->fetch("editcmnt.tpl");
	}
	
	// 削除
	function action( $method ) {
		global $_SESSION;
		global $DSN;
		
		// 削除には管理権限が必要
		if( $_SESSION['permission'] & TBL_ADMIN_WRITE_PERMIT ) {
			
			if( $method == "delcomment" ) {
				// コメントの削除
				$cmnt =& new Tbl_Comments( $DSN, "id", $this->get['cid'] );
				if( $cmnt->isError() ) {
					$this->setError($cmnt->isError());
					return;
				}
				$cmnt->remove();
				$cmnt->close();
			}
			else if( $method == "deltrack" ) {
				// トラックバック削除
				$tr =& new Tbl_Trackbacks( $DSN, "id", $this->get['tid'] );
				if( $tr->isError() ) {
					$this->setError($tr->isError());
					return;
				}
				$tr->remove();
				$tr->close();
			}
		}
		else {
			$this->setError("管理権限がありません");
		}
	}
}
?>