<?php
require_once( "myconfig.php" );
require_once( "NikkiContent.class.php" );
require_once( "NikkiTables.class.php" );
require_once( "Category.class.php" );
require_once( "Smarty.class.php" );


class EditTopic extends NikkiContent {
	
	function EditTopic() {
		parent::NikkiContent();
	}
    
    function getTitle() {
		return "トピック編集";
	}
    
	function getContents() {
		global $DSN;
		
    	$smarty = new Smarty();
    	$id = isset( $this->get["id"] ) ? ($this->get["id"]) : "0";
      	if( $id != "0" ) {
			$nikki =& new Tbl_Nikki( $DSN, "id", $id );
			if( ! $nikki->isError() ) {
	            $smarty->assign( "title" , $nikki->get("title") );
   	         	$smarty->assign( "body"  , $nikki->get("body") );
            	$smarty->assign( "fdelete", $nikki->get("fdelete") ? "checked" : "" );
				$smarty->assign( "category", Category::getMenu( $nikki->get("catid") ) );
            	$nikki->close();
            }
            else {
				$this->setError( $nikki->getError() );
				$id = 0;
			}
		}
		if( $id == "0" ) {
            $smarty->assign( "title" , "" );
            $smarty->assign( "body" , "" );
            $smarty->assign( "fdelete", "" );
			$smarty->assign( "category", Category::getMenu() );
		}
		$smarty->assign( "id", $id );
		return $smarty->fetch("edittopic.tpl");
	}
	
	function getSideMenu() {
		return '<a href="admin.php?content=EditTopic">新規トピック</a>';
	}
	
	function action( $method ) {
		// fdeleteがセットされてないなら削除マーククリア
		if( !isset( $this->post['fdelete']) )
			$this->post['fdelete'] = 0;
		$id = parent::action($method);
		// エラーが無く、かつトラックバックURL（tback）が空でないなら
		if(!$this->isError() && ($this->post['tback'] != "" ) ) {
			$this->sendTBPing($this->post['tback'], $id, $this->post['title'], $this->post['body'] );
		}
	}
	
    // Trackback pingを送る
	function sendTBPing( $targeturl, $id, $title, $excerpt ) {
		global $DSN;
		
		$port = 80;
		$query = "";
		// 自サイトURLを取り出しておく
		$settings =& new Tbl_Settings( $DSN , "id", "1" );
		$siteuri = $settings->get("siteuri");
		$maintitle = $settings->get("maintitle");
		$settings->close();
		
		// POSTするデータの作成
		$post = "title=".urlencode($title);
		$post = $post. "&url=".urlencode( $siteuri."?id=".$id );
		$post = $post. "&excerpt=".urlencode($excerpt);
		$post = $post. "&blog_name=".urlencode($maintitle);
      
		// ping先URLからホスト名やパスを取り出す
		$pingurl = parse_url( $targeturl );
		if( isset( $pingurl['query']) ) $query = "?".$pingurl['query'];
		if( isset( $pingurl['port']) ) $port = $pingurl['port'];
		
		// HTTPリクエストの作成
		$req = "POST ".$pingurl['path'].$query." HTTP/1.0\r\n";
		$req = $req. "Host: ".$pingurl['host']."\r\n";
		$req = $req. "User-Agent: PHP/".phpversion()."\r\n";
		$req = $req. "Content-type: application/x-www-form-urlencoded\r\n";
		$req = $req. "Content-Length: ".strlen($post)."\r\n\r\n";
		$req = $req. $post."\r\n";
		
		// ソケットを開く
		$fn = fsockopen( $pingurl['host'], $port );
		if( $fn === false ) {
			$this->setError("トラックバックPINGに失敗しました" );
			return;
		}
		
		// 送信
		fputs( $fn, $req );
		// レスポンス受信
		$res = "";
		while(!feof($fn)) {
			$res = $res . fgets( $fn );
		}
		fclose($fn);
		// レスポンスのボディに<error>1</error>が含まれていればエラー
		list($rhead, $rbody) = split("\r\n\r\n", $res, 2 );
		if( strstr( $rbody, "<error>1</error>") !== FALSE ) {
        	$this->setError( urlencode($rbody) );
        	return;
        }
	}
}
?>